<html>
<head>
<title>Ogre::RTShader::SubRenderStateFactory Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html">SubRenderStateFactory</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::SubRenderStateFactory Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::SubRenderStateFactory" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Abstract factory interface for creating <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> implementation instances.  
 <a href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::SubRenderStateFactory:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1SubRenderStateFactory__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1SubRenderStateFactory_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1SubRenderStateFactory_inherit__map" id="Ogre_1_1RTShader_1_1SubRenderStateFactory_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="60,5,215,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1SubRenderStateFactory-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a7482107fd30c95cb68b26ae03e3a3b0e">SubRenderStateFactory</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a9b3e25bb3aa398c8068cd5790002899d">~SubRenderStateFactory</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a62346d71416d91a03f429ed7404ca450">getType</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of this sub render state factory.  <a href="#a62346d71416d91a03f429ed7404ca450"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a954d30cb82307ae1ba785792b833b689">createInstance</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> sub class it suppose to create.  <a href="#a954d30cb82307ae1ba785792b833b689"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae01bc8b25b77ffcc05f5b1f33a4dd06e">createInstance</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, <a class="el" href="classOgre_1_1PropertyAbstractNode.html">PropertyAbstractNode</a> *prop, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, <a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *translator)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> based on script properties.  <a href="#ae01bc8b25b77ffcc05f5b1f33a4dd06e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae3f721960f23b73933bd7ad128f8fa77">createInstance</a> (<a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *compiler, <a class="el" href="classOgre_1_1PropertyAbstractNode.html">PropertyAbstractNode</a> *prop, <a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *texState, <a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *translator)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> based on script properties.  <a href="#ae3f721960f23b73933bd7ad128f8fa77"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a54a6f6eba1624fef1de9c20eb7b0a6b5">createOrRetrieveInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *translator)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the previous instance the SRS in the script translator or create a new instance if not found.  <a href="#a54a6f6eba1624fef1de9c20eb7b0a6b5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a23839e5fc35257e4ffb9076e2aaf9409">destroyInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the given instance.  <a href="#a23839e5fc35257e4ffb9076e2aaf9409"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ab89670718152dcb35f2428cf5909ed99">destroyAllInstances</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy all the instances that created by this factory.  <a href="#ab89670718152dcb35f2428cf5909ed99"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ada31909080bae96784504be42d9bd77c">writeInstance</a> (<a class="el" href="classOgre_1_1MaterialSerializer.html">MaterialSerializer</a> *ser, <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *srcPass, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *dstPass)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the given sub-render state instance using the material serializer.  <a href="#ada31909080bae96784504be42d9bd77c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a10b565ec536c0539e44fb1147ef777a4">writeInstance</a> (<a class="el" href="classOgre_1_1MaterialSerializer.html">MaterialSerializer</a> *ser, <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState, const <a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *srcTextureUnit, const <a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *dstTextureUnit)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the given sub-render state instance using the material serializer.  <a href="#a10b565ec536c0539e44fb1147ef777a4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a4e68465e17cac6e993b4bd98b644e227">createInstanceImpl</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create instance implementation method.  <a href="#a4e68465e17cac6e993b4bd98b644e227"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a3a82a80aebd5d2329d4bc1466fd883a0">mSubRenderStateList</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Abstract factory interface for creating <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> implementation instances. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Plugins or 3rd party applications can add new types of sub render states to the <a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a> System by creating subclasses of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> class. Because multiple instances of these sub class may be required, a factory class to manage the instances is also required. </dd></dl>
<dl class="user"><dt><b></b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html" title="Abstract factory interface for creating SubRenderState implementation instances.">SubRenderStateFactory</a> subclasses must allow the creation and destruction of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> subclasses. They must also be registered with the <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html#ac266946244d79b2d4732607ae9479bd9" title="Add sub render state factory.">ShaderGenerator::addSubRenderStateFactory</a>. All factories have a type which identifies them and the sub class of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> they creates. </dd></dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00230">230</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7482107fd30c95cb68b26ae03e3a3b0e"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::SubRenderStateFactory" ref="a7482107fd30c95cb68b26ae03e3a3b0e" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a7482107fd30c95cb68b26ae03e3a3b0e">Ogre::RTShader::SubRenderStateFactory::SubRenderStateFactory</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00234">234</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9b3e25bb3aa398c8068cd5790002899d"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::~SubRenderStateFactory" ref="a9b3e25bb3aa398c8068cd5790002899d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a9b3e25bb3aa398c8068cd5790002899d">Ogre::RTShader::SubRenderStateFactory::~SubRenderStateFactory</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a954d30cb82307ae1ba785792b833b689"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::createInstance" ref="a954d30cb82307ae1ba785792b833b689" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a954d30cb82307ae1ba785792b833b689">Ogre::RTShader::SubRenderStateFactory::createInstance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> sub class it suppose to create. </p>

</div>
</div>
<a class="anchor" id="ae01bc8b25b77ffcc05f5b1f33a4dd06e"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::createInstance" ref="ae01bc8b25b77ffcc05f5b1f33a4dd06e" args="(ScriptCompiler *compiler, PropertyAbstractNode *prop, Pass *pass, SGScriptTranslator *translator)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a954d30cb82307ae1ba785792b833b689">Ogre::RTShader::SubRenderStateFactory::createInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1PropertyAbstractNode.html">PropertyAbstractNode</a> *&#160;</td>
          <td class="paramname"><em>prop</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *&#160;</td>
          <td class="paramname"><em>translator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> based on script properties. </p>
<p>This method is called in the context of script parsing and let this factory the opportunity to create custom <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instances based on extended script properties. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">compiler</td><td>The compiler instance. </td></tr>
    <tr><td class="paramname">prop</td><td>The abstract property node. </td></tr>
    <tr><td class="paramname">pass</td><td>The pass that is the parent context of this node. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00255">255</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae3f721960f23b73933bd7ad128f8fa77"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::createInstance" ref="ae3f721960f23b73933bd7ad128f8fa77" args="(ScriptCompiler *compiler, PropertyAbstractNode *prop, TextureUnitState *texState, SGScriptTranslator *translator)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a954d30cb82307ae1ba785792b833b689">Ogre::RTShader::SubRenderStateFactory::createInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ScriptCompiler.html">ScriptCompiler</a> *&#160;</td>
          <td class="paramname"><em>compiler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1PropertyAbstractNode.html">PropertyAbstractNode</a> *&#160;</td>
          <td class="paramname"><em>prop</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&#160;</td>
          <td class="paramname"><em>texState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *&#160;</td>
          <td class="paramname"><em>translator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create an instance of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> based on script properties. </p>
<p>This method is called in the context of script parsing and let this factory the opportunity to create custom <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instances based on extended script properties. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">compiler</td><td>The compiler instance. </td></tr>
    <tr><td class="paramname">prop</td><td>The abstract property node. </td></tr>
    <tr><td class="paramname">texState</td><td>The pass that is the parent context of this node. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00264">264</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4e68465e17cac6e993b4bd98b644e227"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::createInstanceImpl" ref="a4e68465e17cac6e993b4bd98b644e227" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a4e68465e17cac6e993b4bd98b644e227">Ogre::RTShader::SubRenderStateFactory::createInstanceImpl</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create instance implementation method. </p>
<p>Each sub class of this interface must implement this method in which it will allocate the specific sub class of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>. </p>

</div>
</div>
<a class="anchor" id="a54a6f6eba1624fef1de9c20eb7b0a6b5"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::createOrRetrieveInstance" ref="a54a6f6eba1624fef1de9c20eb7b0a6b5" args="(SGScriptTranslator *translator)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a54a6f6eba1624fef1de9c20eb7b0a6b5">Ogre::RTShader::SubRenderStateFactory::createOrRetrieveInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">SGScriptTranslator</a> *&#160;</td>
          <td class="paramname"><em>translator</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Retrieve the previous instance the SRS in the script translator or create a new instance if not found. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">translator</td><td>The translator instance holding existing scripts. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab89670718152dcb35f2428cf5909ed99"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::destroyAllInstances" ref="ab89670718152dcb35f2428cf5909ed99" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ab89670718152dcb35f2428cf5909ed99">Ogre::RTShader::SubRenderStateFactory::destroyAllInstances</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy all the instances that created by this factory. </p>

</div>
</div>
<a class="anchor" id="a23839e5fc35257e4ffb9076e2aaf9409"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::destroyInstance" ref="a23839e5fc35257e4ffb9076e2aaf9409" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a23839e5fc35257e4ffb9076e2aaf9409">Ogre::RTShader::SubRenderStateFactory::destroyInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Destroy the given instance. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The instance to destroy. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a62346d71416d91a03f429ed7404ca450"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::getType" ref="a62346d71416d91a03f429ed7404ca450" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a62346d71416d91a03f429ed7404ca450">Ogre::RTShader::SubRenderStateFactory::getType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of this sub render state factory. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The type string should be the same as the type of the <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> sub class it is going to create. </dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#ae91b7b8f76848d67652b6e5832a27a49" title="Get the type of this sub render state.">SubRenderState::getType</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ada31909080bae96784504be42d9bd77c"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::writeInstance" ref="ada31909080bae96784504be42d9bd77c" args="(MaterialSerializer *ser, SubRenderState *subRenderState, Pass *srcPass, Pass *dstPass)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ada31909080bae96784504be42d9bd77c">Ogre::RTShader::SubRenderStateFactory::writeInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MaterialSerializer.html">MaterialSerializer</a> *&#160;</td>
          <td class="paramname"><em>ser</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>srcPass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>dstPass</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the given sub-render state instance using the material serializer. </p>
<p>This method is called in the context of material serialization. It is useful for integrating into bigger context of material exporters from various environment that want to take advantage of the RT Shader System. Sub classes of this interface should override in case they need to write custom properties into the script context. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">ser</td><td>The material serializer instance. </td></tr>
    <tr><td class="paramname">subRenderState</td><td>The sub render state instance to write down. </td></tr>
    <tr><td class="paramname">srcPass</td><td>The source pass. </td></tr>
    <tr><td class="paramname">dstPass</td><td>The generated shader based pass. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00290">290</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a10b565ec536c0539e44fb1147ef777a4"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::writeInstance" ref="a10b565ec536c0539e44fb1147ef777a4" args="(MaterialSerializer *ser, SubRenderState *subRenderState, const TextureUnitState *srcTextureUnit, const TextureUnitState *dstTextureUnit)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ada31909080bae96784504be42d9bd77c">Ogre::RTShader::SubRenderStateFactory::writeInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MaterialSerializer.html">MaterialSerializer</a> *&#160;</td>
          <td class="paramname"><em>ser</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&#160;</td>
          <td class="paramname"><em>srcTextureUnit</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TextureUnitState.html">TextureUnitState</a> *&#160;</td>
          <td class="paramname"><em>dstTextureUnit</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the given sub-render state instance using the material serializer. </p>
<p>This method is called in the context of material serialization. It is useful for integrating into bigger context of material exporters from various environment that want to take advantage of the RT Shader System. Sub classes of this interface should override in case they need to write custom properties into the script context. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">ser</td><td>The material serializer instance. </td></tr>
    <tr><td class="paramname">subRenderState</td><td>The sub render state instance to write down. </td></tr>
    <tr><td class="paramname">srcTextureUnit</td><td>The source texture unit state. </td></tr>
    <tr><td class="paramname">dstTextureUnit</td><td>The generated shader based texture unit state. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00301">301</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a3a82a80aebd5d2329d4bc1466fd883a0"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateFactory::mSubRenderStateList" ref="a3a82a80aebd5d2329d4bc1466fd883a0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a3a82a80aebd5d2329d4bc1466fd883a0">Ogre::RTShader::SubRenderStateFactory::mSubRenderStateList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00311">311</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:34
</p>
</body>
</html>
